#![allow(deprecated)]
use std::fmt;
use std::str;
/// Opsgenie region for the account linked to the provided API key.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum OpsgenieRegion {
    #[serde(rename = "US")]
    Us,
    #[serde(rename = "EU")]
    Eu,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl OpsgenieRegion {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            OpsgenieRegion::Us => "US",
            OpsgenieRegion::Eu => "EU",
            OpsgenieRegion::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for OpsgenieRegion {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for OpsgenieRegion {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for OpsgenieRegion {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<OpsgenieRegion, conjure_object::plain::ParseEnumError> {
        match v {
            "US" => Ok(OpsgenieRegion::Us),
            "EU" => Ok(OpsgenieRegion::Eu),
            v => v.parse().map(|v| OpsgenieRegion::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for OpsgenieRegion {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<OpsgenieRegion, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the OpsgenieRegion enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
